/*******************************************************************
**
** HyperBase was designed and implemented by:
**
**	Uffe Kock Wiil 		(kock@iesd.auc.dk)
**	Claus Bo Nielsen 	(cbn@cci.dk)
**	Carsten Ruseng Jakobsen (ruseng@sun.com)
**	Finn Soelvsten
**	Per Magnus Petersen
**	Poul Larsen
**	Hans Mejdahl Jeppesen
**
** at The University of Aalborg in Denmark autumn 1989, and is provided
** for unrestricted use provided that this legend is included on all
** tape media and as a part of the software program in whole or part.
** Users may copy or modify HyperBase without charge, but are not
** authorized to license or distribute it to anyone else except as part
** of a product or program developed by the user.
**  
** HyperBase IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING
** THE WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A
** PARTICULAR PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR
** TRADE PRACTICE.
**  
** HyperBase is provided with no support and without any obligation on
** the part of the authors, to assist in its use, correction,
** modification or enhancement.
** 
** THE AUTHORS SHALL HAVE NO LIABILITY WITH RESPECT TO THE INFRINGEMENT
** OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY HyperBase OR ANY PART
** THEREOF.
** 
** In no event will the authors and/or The University of Aalborg be
** liable for any lost revenue or profits or other special, indirect and
** consequential damages, even if the authors and/or The University of
** Aalborg has been advised of the possibility of such damages.
** 
** Please address all correspondence to:
** 
** Uffe Kock Wiil
** Department of Computer Science,
** The University of Aalborg,      Email:  kock@iesd.auc.dk
** Fredrik Bajers Vej 7E,          Phone:  + 45 98 15 42 11 (Ext 5051)
** DK-9220 Aalborg, Denmark.       Fax:    + 45 98 15 81 29
**
*******************************************************************/

#include "slist.hh"	

int slist::append(listent a) 
{
  if (last)
    last = last->next = new slink(a,last->next);
  else 
  {
    last = new slink(a,0);
    last->next = last; 
  }
  return 0;
}

listent slist::remove_front() 
{
  if (last != 0) 
  {
    slink* f = last->next;
    listent r = f->e;
    if (f == last)
      last = 0;
    else
      last->next = f->next;
    delete f;
    return r;
  }
  else
  {
    listent r = 0;
    return r;
  }
}

int slist::count() 
{
  if (last == 0) 
    return 0; 
  else 
  {
    slink* l = last;
    int i = 0;
    do
    {
      i++;
      l = l->next;
    }
    while (l != last);
    return i;
  }
}

void slist::clear()
{
  slink* l = last;
  if (l == 0) return;
  do
  {
    slink* ll = l;
    l = l->next;
    delete ll;
  }
  while (l != last);
  last = 0;
}
